/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _CAPTUREC_H
#define _CAPTUREC_H


#include <dnpap.h>
#include <ring.h>
#include <snmp.h>
#include <mibsup.h>


typedef struct _CAPTURE
{
    ULONG           Time;
    ULONG           ID;
	WORD			Len;
	
} CAPTURE;


typedef struct _BUFFER
{
    LONG            ChannelIndex;
    LONG            FullStatus;
    LONG            FullAction;
    LONG            CaptureSliceSize;
    LONG            DownloadSliceSize;
    LONG            DownloadOffset;
    LONG            MaxOctetsRequested;
    LONG            MaxOctetsGranted;
    LONG            MaxOctetsAvailable;
    LONG            CapturedPkts;
    ULONG           TurnOnTime;
    ULONG           TurnOnTimeMsec;
    BYTE            Owner[SNMP_SIZE_BUFCHR];
    WORD            OwnerLen;
    LONG            Status;

    Ring           *RingBuf;
	
} BUFFER;



BOOLEAN CaptureConfigInit(VOID);

BOOLEAN CaptureInit (BUFFER *buffer);
BOOLEAN CaptureStart (BUFFER *buffer);
BOOLEAN CaptureStop (BUFFER *buffer);        

LONG CaptureElems(LONG available, LONG size);


#endif
