/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _NEURO_M_H
#define _NEURO_M_H


#include <dnpap.h>
#include <snmp.h>


#define NMIB_BASE       BTNG_MIB,7
#define NMIB_BASELEN    BTNG_MIBLEN+1


enum { NMIB_NRNETWORKS, NMIB_RUNNINGNRNETWORKS,
       NMIB_INDEX,
       NMIB_NRLAYERS, NMIB_NETREFRESH,
       NMIB_TRAIN,
       NMIB_REQSIZE, NMIB_GRANTSIZE, NMIB_BATCHSIZE,
       NMIB_LRATE, NMIB_MOMENTUM,
       NMIB_TOTALSTEPS, NMIB_TRAININGSTEPS,
       NMIB_ERROR, 
       NMIB_OWNER, NMIB_STATUS, 
       NMIB_NRNEURONS, 
       NMIB_DATASRC, NMIB_DATASRCMAX, NMIB_DATASRCMIN,
       NMIB_DATASRCAVERAGEMETHOD, NMIB_DATASRCSTEPS, 
       NMIB_DATASRCTRAP, NMIB_DATASRCTRAPCOMM,
       NMIB_DATASRCTHRESHOLDCHECK,
       NMIB_DATASRCVALUE, NMIB_OUTPUTVALUE,
       NMIB_DATASRCTHRESHOLDVALUE
};


#define NMIB_NRNETWORKSID               1,0,0
#define NMIB_RUNNINGNRNETWORKSID        2,0,0
#define NMIB_INDEXID                    3,1,1
#define NMIB_NRLAYERSID                 3,1,2      
#define NMIB_NETREFRESHID               3,1,3
#define NMIB_TRAINID                    3,1,4
#define NMIB_REQSIZEID                  3,1,5 
#define NMIB_GRANTSIZEID                3,1,6
#define NMIB_BATCHSIZEID                3,1,7 
#define NMIB_LRATEID                    3,1,8 
#define NMIB_MOMENTUMID                 3,1,9
#define NMIB_TOTALSTEPSID               3,1,10
#define NMIB_TRAININGSTEPSID            3,1,11
#define NMIB_ERRORID                    3,1,12
#define NMIB_OWNERID                    3,1,13
#define NMIB_STATUSID                   3,1,14      
#define NMIB_NRNEURONSID                4,1,3      
#define NMIB_DATASRCID                  5,1,4
#define NMIB_DATASRCMAXID               5,1,5
#define NMIB_DATASRCMINID               5,1,6
#define NMIB_DATASRCAVERAGEMETHODID     5,1,7
#define NMIB_DATASRCSTEPSID             5,1,8
#define NMIB_DATASRCTRAPID              5,1,9
#define NMIB_DATASRCTRAPCOMMID          5,1,10
#define NMIB_DATASRCTHRESHOLDCHECKID    5,1,11
#define NMIB_DATASRCVALUEID             5,1,12
#define NMIB_OUTPUTVALUEID              5,1,13
#define NMIB_DATASRCTHRESHOLDVALUEID    6,1,5

      
#define NMIB_COFFSET	1
#define NMIB_LOFFSET	2
#define NMIB_NOFFSET	3
#define NMIB_IOFFSET	4


#define NEUROSETID(base, index) \
{ \
LONG tmp[] = { index }; \
  \
    base[NMIB_BASELEN] = tmp[0];   \
    base[NMIB_BASELEN+1] = tmp[1]; \
    base[NMIB_BASELEN+2] = tmp[2]; \
}


BOOLEAN NeuroMInit(VOID);

WORD NeuroIndex(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroLayerIndex(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroLayerIndexLayer(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroLayerNeuronIndex(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroLayerNeuronIndexLayer(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroLayerNeuronIndexNeuron(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroLayerNeuronValueIndex(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroLayerNeuronValueIndexLayer(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroLayerNeuronValueIndexNeuron(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroLayerNeuronValueIndexValue(SNMP_OBJECT *obj, WORD idlen);

WORD NeuroNrNetworks(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroRunningNrNetworks(SNMP_OBJECT *obj, WORD idlen);

WORD NeuroNrLayers(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroNetRefresh(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroRequestComm(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroTrain(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroRequestedSize(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroGrantedSize(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroBatchSize(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroLearningRate(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroMomentum(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroTotalSteps(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroTrainingSteps(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroError(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroOwner(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroStatus(SNMP_OBJECT *obj, WORD idlen);

WORD NeuroNrNeurons(SNMP_OBJECT *obj, WORD idlen);

WORD NeuroDataSource(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroDataSourceMax(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroDataSourceMin(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroDataSourceAverageMethod(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroDataSourceAverageSteps(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroDataSourceTrap(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroDataSourceTrapComm(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroDataSourceThresholdCheck(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroDataSourceValue(SNMP_OBJECT *obj, WORD idlen);
WORD NeuroDataSourceOutputValue(SNMP_OBJECT *obj, WORD idlen);

WORD NeuroDataSourceThresholdValue(SNMP_OBJECT *obj, WORD idlen);


#endif					     
