/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _DCAPTUREC_H
#define _DCAPTUREC_H


#include <dnpap.h>
#include <ring.h>
#include <snmp.h>
#include <mibsup.h>


typedef struct _DNPAP_CAPTURE
{
    ULONG           Time;
    ULONG           ID;
	WORD			Len;
	
} DNPAP_CAPTURE;


typedef struct _DNPAP_BUFFER
{
    LONG            ChannelIndex;
    LONG            FullStatus;
    LONG            FullAction;
    LONG            CaptureSliceSize;
    LONG            DownloadSliceSize;
    LONG            DownloadOffset;
    LONG            MaxOctetsRequested;
    LONG            MaxOctetsGranted;
    LONG            MaxOctetsAvailable;
    LONG            CapturedPkts;
    ULONG           TurnOnTime;
    ULONG           TurnOnTimeMsec;
    BYTE            Owner[SNMP_SIZE_BUFCHR];
    WORD            OwnerLen;
    LONG            Status;

    Ring           *RingBuf;
	
} DNPAP_BUFFER;



BOOLEAN DnpapCaptureConfigInit(VOID);

BOOLEAN DnpapCaptureInit (DNPAP_BUFFER *buffer);
BOOLEAN DnpapCaptureStart (DNPAP_BUFFER *buffer);
BOOLEAN DnpapCaptureStop (DNPAP_BUFFER *buffer);

LONG DnpapCaptureElems(LONG available, LONG size);
      

#endif
