/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#include <dnpap.h>
#include <memory.h>
#include <dmath.h>
#include <maxmem.h>
#include <snmp.h>
#include <stdlib.h>

#include "dlog.h"


static CHAR MODULE[] = "DnpapLogM";


WORD DnpapLogEventIndex(SNMP_OBJECT *obj, WORD idlen, DnpapRmonLog *log)
{
	switch (obj->Request)
	{
    case SNMP_PDU_NEXT:
	case SNMP_PDU_GET:
        obj->Syntax.LngInt = obj->Id[idlen];
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		return SNMP_READONLY;
	}
    return SNMP_GENERROR;
}


WORD DnpapLogIndex(SNMP_OBJECT *obj, WORD idlen, DnpapRmonLog *log)
{
	switch (obj->Request)
	{
    case SNMP_PDU_NEXT:
	case SNMP_PDU_GET:
        obj->Syntax.LngInt = obj->Id[idlen+1];
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		return SNMP_READONLY;
	}
    return SNMP_GENERROR;
}


WORD DnpapLogTime(SNMP_OBJECT *obj, WORD idlen, DnpapRmonLog *log)
{
	switch (obj->Request)
	{
    case SNMP_PDU_NEXT:
	case SNMP_PDU_GET:
		obj->Syntax.LngUns = log->Time;
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		return SNMP_READONLY;
	}
    return SNMP_GENERROR;
}


WORD DnpapLogDescription(SNMP_OBJECT *obj, WORD idlen, DnpapRmonLog *log)
{
	switch (obj->Request)
	{
    case SNMP_PDU_NEXT:
	case SNMP_PDU_GET:
		memcpy(obj->Syntax.BufChr, log->Description, obj->SyntaxLen = log->DescrLen);
		return SNMP_NOERROR;
	case SNMP_PDU_SET:
		return SNMP_READONLY;
	}
    return SNMP_GENERROR;
}


DnpapRmonLog *NewDnpapRmonLog(WORD nrlogs)
{
	return DnpapMalloc(nrlogs*sizeof(DnpapRmonLog));
}


DnpapRmonLog *ReNewDnpapRmonLog(DnpapRmonLog* ptr, WORD nrlogs, WORD oldnrlogs, WORD maxnrlogs)
{           
WORD n, nold;

	if (nrlogs > maxnrlogs || ((LONG)nrlogs*sizeof(DnpapRmonLog) > MemoryGetMaxChunk()))
		return NULL;
    n = ((nrlogs-1)/MINALLOCLOGS)*MINALLOCLOGS+MINALLOCLOGS;
    nold = ((oldnrlogs-1)/MINALLOCLOGS)*MINALLOCLOGS+MINALLOCLOGS;
    if (ptr == NULL || abs(n-nold) >= MINALLOCLOGS)  
    {
        return DnpapRealloc(ptr, min(n, maxnrlogs)*sizeof(DnpapRmonLog));
    }        
    else
        return ptr;
}


VOID DelDnpapRmonLog(DnpapRmonLog* ptr)
{
    DnpapFree(ptr);
}
