/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _NIT_H_
#define _NIT_H_

 
#include <nw.h>
#include <mac.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <net/if.h>

      
#define NIT_MTU 1500


typedef struct ifnet 	IFNET;


typedef struct _NIT_DESCR	NIT_DESCR;


struct _NIT_DESCR
{
    NIT_DESCR   *next;
    NW_DG       *nw; 
    MAC_IFACE   *mac;
	ULONG		offset;		/* offset of interface data into kernel memory */

    ULONG       LostPkts;
    ULONG       Octets;
    ULONG       Pkts;
    ULONG       BroadcastPkts;
    ULONG       MulticastPkts;
    ULONG       CRCAlignErrors;         
    ULONG       UndersizePkts;            
    ULONG       OversizePkts;             
    ULONG       Fragments;
    ULONG       Jabbers;         
    ULONG       Collisions;
    ULONG       BufferedPkts;
    ULONG       StackedPkts;
    ULONG       DiscardedPkts;
    ULONG       TruncatedPkts; 

	/* extra interface parameters from kernel memory */
	ULONG		InPkts;
	ULONG		InErrors;
	ULONG		OutPkts;
	ULONG		OutErrors;
};           


BOOLEAN NitInit(void);
void    NitExit(void);


#endif


