/* Beholder RMON ethernet network monitor,Copyright (C) 1993 DNPAP group */
/* See file COPYING 'GNU General Public Licence' for copyright details   */
#ifndef _NWICMP_H
#define _NWICMP_H
    

#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <arpa/inet.h>

#include <block.h>
#include <dnpap.h>

#include "nw.h"
            

#define NWICMP_SIZE_ENTRY        32
#define NWICMP_SIZE_HOST        256
#define NWICMP_SIZE_PACKET     4096


#define INADDR_NONE     0xffffffff

                      
enum NwIcmpErrors
{
    NWICMP_OK = NWICMP_ERROR, 
    NWICMP_PARAM, NWICMP_PROTO, NWICMP_INIT, NWICMP_ROOT,
    NWICMP_NEWICMP, NWICMP_OPEN, 
    NWICMP_ADDLIST,
    NWICMP_ADDR, NWICMP_BLOCK,
    NWICMP_READ, NWICMP_RECV, NWICMP_SEND, 
    NWICMP_WEVENT, NWICMP_EEVENT, NWICMP_NEVENT
};


typedef struct _NwIcmp
{
	INT Socket;
    CHAR  *Host;
    ULONG  Addr;
    USHORT Ident;
    
} NwIcmp;
    

typedef struct _NwIcmpDg
{          
    NW_DG  NwInfo;
    NwIcmp IcmpInfo;
    
    BLOCK          *Block;
    
    struct _NwIcmpDg *Prev;
    struct _NwIcmpDg *Next;
    
} NwIcmpDg;

      

extern NW_DG_IFACE IcmpDgIface;


BOOLEAN NwIcmpInit(VOID);
BOOLEAN NwIcmpExit(VOID);

NW_DG  *NwIcmpAccept(char *addr, NW_DG_RECV_CALL recv, VOID *param);
NW_DG  *NwIcmpConnect(char *addr, NW_DG_RECV_CALL recv, VOID *param);
BOOLEAN NwIcmpSend(NW_DG *dg, BYTE *frame, INT len);
BOOLEAN NwIcmpSendTo(NW_DG *dg, CHAR *addr, BYTE *frame, INT len);
BOOLEAN NwIcmpClose(NW_DG *dg);


#endif
